"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleFuncs = exports["default"] = exports.VXETablePluginShortcutKey = exports.SKey = void 0;
var _xeUtils = _interopRequireDefault(require("xe-utils"));
var _handleFuncs;
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var SKey = exports.SKey = /*#__PURE__*/function () {
  function SKey(realKey, specialKey, funcName, kConf) {
    _classCallCheck(this, SKey);
    _defineProperty(this, "realKey", void 0);
    _defineProperty(this, "specialKey", void 0);
    _defineProperty(this, "funcName", void 0);
    _defineProperty(this, "kConf", void 0);
    this.realKey = realKey;
    this.specialKey = specialKey;
    this.funcName = funcName;
    this.kConf = kConf;
  }
  return _createClass(SKey, [{
    key: "trigger" /* TRIGGER */,
    value: function trigger(params, evnt) {
      if (!this.specialKey || evnt["".concat(this.specialKey, "Key")]) {
        if (this.funcName && handleFuncs[this.funcName]) {
          return handleFuncs[this.funcName](params, evnt);
        }
      }
    }
  }, {
    key: "emit" /* EMIT */,
    value: function emit(params, evnt) {
      if (!this.specialKey || evnt["".concat(this.specialKey, "Key")]) {
        if (this.kConf && this.kConf.callback) {
          return this.kConf.callback(params, evnt);
        }
      }
    }
  }]);
}();
var arrowKeys = 'right,up,left,down'.split(',');
var specialKeys = 'alt,ctrl,shift,meta'.split(',');
var settingMaps = {};
var listenerMaps = {};
var disabledMaps = {};
function getEventKey(key) {
  if (arrowKeys.indexOf(key.toLowerCase()) > -1) {
    return "Arrow".concat(key);
  }
  return key;
}
function isTriggerPage(params) {
  return !params.$table.getActiveRecord();
}
function handleChangePage(func) {
  return function (params, evnt) {
    var $grid = params.$grid,
      $table = params.$table;
    var tableProps = $table.props;
    var mouseConfig = tableProps.mouseConfig;
    var _$table$getComputeMap = $table.getComputeMaps(),
      computeMouseOpts = _$table$getComputeMap.computeMouseOpts;
    var mouseOpts = computeMouseOpts.value;
    if ($grid && mouseConfig && mouseOpts.selected !== true && ['input', 'textarea'].indexOf(evnt.target.tagName.toLowerCase()) === -1 && isTriggerPage(params)) {
      var _$grid$getRefMaps = $grid.getRefMaps(),
        refPager = _$grid$getRefMaps.refPager;
      var $pager = refPager.value;
      if ($pager) {
        evnt.preventDefault();
        $pager[func](evnt);
      }
    }
  };
}
function handleCellTabMove(isLeft) {
  return function (params, evnt) {
    var $table = params.$table;
    var targetParams = $table.getActiveRecord() || $table.getSelectedCell();
    if (targetParams) {
      $table.moveTabSelected(targetParams, isLeft, evnt);
    }
    return false;
  };
}
function handleCellEnterMove(isTop) {
  return function (params, evnt) {
    var $table = params.$table;
    var targetParams = $table.getActiveRecord() || $table.getSelectedCell();
    if (targetParams) {
      $table.moveSelected(targetParams, false, !isTop, false, isTop, evnt);
    }
    return false;
  };
}
function handleCellMove(arrowIndex) {
  return function (params, evnt) {
    var $table = params.$table;
    var selecteParams = $table.getSelectedCell();
    var arrows = [0, 0, 0, 0];
    arrows[arrowIndex] = 1;
    if (selecteParams) {
      $table.moveSelected(selecteParams, arrows[0], arrows[1], arrows[2], arrows[3], evnt);
      return false;
    }
  };
}
function handleCurrentRowMove(isDown) {
  return function (params, evnt) {
    var $table = params.$table;
    var tableProps = $table.props;
    var highlightCurrentRow = tableProps.highlightCurrentRow;
    if (highlightCurrentRow) {
      var currentRow = $table.getCurrentRecord();
      if (currentRow) {
        $table.moveCurrentRow(!isDown, isDown, evnt);
        return false;
      }
    }
  };
}
/**
 * 快捷键处理方法
 */
var handleFuncs = exports.handleFuncs = (_handleFuncs = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_handleFuncs, "table.edit.actived" /* TABLE_EDIT_ACTIVED */, function tableEditActived(params, evnt) {
  var $table = params.$table;
  var selected = $table.getSelectedCell();
  if (selected) {
    evnt.preventDefault();
    $table.setActiveCell(selected.row, selected.column.field);
    return false;
  }
}), "table.edit.closed" /* TABLE_EDIT_CLOSED */, function tableEditClosed(params, evnt) {
  var $table = params.$table;
  var props = $table.props;
  var mouseConfig = props.mouseConfig,
    editConfig = props.editConfig;
  var _$table$getComputeMap2 = $table.getComputeMaps(),
    computeMouseOpts = _$table$getComputeMap2.computeMouseOpts;
  var mouseOpts = computeMouseOpts.value;
  if (editConfig) {
    var actived = $table.getActiveRecord();
    if (actived) {
      evnt.preventDefault();
      var cleatRest = $table.clearActived();
      if (mouseConfig && mouseOpts.selected) {
        cleatRest.then(function () {
          return $table.setSelectCell(actived.row, actived.column.field);
        });
      }
      return false;
    }
  }
}), "table.edit.tab.rightMove" /* TABLE_EDIT_TAB_RIGHT_MOVE */, handleCellTabMove(false)), "table.edit.tab.leftMove" /* TABLE_EDIT_TAB_LEFT_MOVE */, handleCellTabMove(true)), "table.edit.enter.upMove" /* TABLE_EDIT_ENTER_UP_MOVE */, handleCellEnterMove(false)), "table.edit.enter.downMove" /* TABLE_EDIT_ENTER_DOWN_MOVE */, handleCellEnterMove(true)), "table.cell.leftMove" /* TABLE_CELL_LEFT_MOVE */, handleCellMove(0)), "table.cell.upMove" /* TABLE_CELL_UP_MOVE */, handleCellMove(1)), "table.cell.rightMove" /* TABLE_CELL_RIGHT_MOVE */, handleCellMove(2)), "table.cell.downMove" /* TABLE_CELL_DOWN_MOVE */, handleCellMove(3)), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_handleFuncs, "table.row.current.topMove" /* TABLE_ROW_CURRENT_TOP_MOVE */, handleCurrentRowMove(false)), "table.row.current.downMove" /* TABLE_ROW_CURRENT_DOWN_MOVE */, handleCurrentRowMove(true)), "pager.prevPage" /* PAGER_PREV_PAGE */, handleChangePage('handlePrevPage')), "pager.nextPage" /* PAGER_NEXT_PAGE */, handleChangePage('handleNextPage')), "pager.prevJump" /* PAGER_PREV_JUMP */, handleChangePage('handlePrevJump')), "pager.nextJump" /* PAGER_NEXT_JUMP */, handleChangePage('handleNextJump')));
function runEvent(key, maps, prop, params, evnt) {
  var skeyList = maps[key.toLowerCase()];
  if (skeyList) {
    return !skeyList.some(function (skey) {
      return skey[prop](params, evnt) === false;
    });
  }
}
function parseKeys(key) {
  var specialKey = '';
  var realKey = '';
  var keys = key.split('+');
  keys.forEach(function (item) {
    item = item.toLowerCase().trim();
    if (specialKeys.indexOf(item) > -1) {
      specialKey = item;
    } else {
      realKey = item;
    }
  });
  if (!realKey || keys.length > 2 || keys.length === 2 && !specialKey) {
    throw new Error("[vxe-table-plugin-shortcut-key] Invalid shortcut key configuration '".concat(key, "'."));
  }
  return {
    realKey: realKey,
    specialKey: specialKey
  };
}
function setKeyQueue(maps, kConf, funcName) {
  var _parseKeys = parseKeys(kConf.key),
    realKey = _parseKeys.realKey,
    specialKey = _parseKeys.specialKey;
  var skeyList = maps[realKey];
  if (!skeyList) {
    skeyList = maps[realKey] = [];
  }
  if (skeyList.some(function (skey) {
    return skey.realKey === realKey && skey.specialKey === specialKey;
  })) {
    throw new Error("[vxe-table-plugin-shortcut-key] Shortcut key conflict '".concat(kConf.key, "'."));
  }
  skeyList.push(new SKey(realKey, specialKey, funcName, kConf));
}
function parseDisabledKey(options) {
  _xeUtils["default"].each(options.disabled, function (conf) {
    var opts = _xeUtils["default"].isString(conf) ? {
      key: conf
    } : conf;
    setKeyQueue(disabledMaps, _xeUtils["default"].assign({
      callback: function callback() {
        return false;
      }
    }, opts));
  });
}
function parseSettingKey(options) {
  _xeUtils["default"].each(options.setting, function (opts, funcName) {
    var kConf = _xeUtils["default"].isString(opts) ? {
      key: opts
    } : opts;
    if (!handleFuncs[funcName]) {
      console.error("[vxe-table-plugin-shortcut-key] '".concat(funcName, "' not exist."));
    }
    setKeyQueue(settingMaps, kConf, funcName);
  });
}
function parseListenerKey(options) {
  _xeUtils["default"].each(options.listener, function (callback, key) {
    if (!_xeUtils["default"].isFunction(callback)) {
      console.error("[vxe-table-plugin-shortcut-key] '".concat(key, "' requires the callback function to be set."));
    }
    setKeyQueue(listenerMaps, {
      key: key,
      callback: callback
    });
  });
}
/**
 * 设置参数
 * @param options 参数
 */
function pluginSetup(options) {
  if (options) {
    parseDisabledKey(options);
    parseSettingKey(options);
    parseListenerKey(options);
  }
}
/**
 * 基于 vxe-table 表格的扩展插件，为键盘操作提供快捷键设置
 */
var VXETablePluginShortcutKey = exports.VXETablePluginShortcutKey = {
  setup: pluginSetup,
  install: function install(vxetable, options) {
    // 检查版本
    if (!/^(4)\./.test(vxetable.version) && !/v4/i.test(vxetable.v)) {
      console.error('[vxe-table-plugin-shortcut-key 4.x] Version vxe-table 4.x is required');
    }
    if (options) {
      pluginSetup(options);
    }
    vxetable.interceptor.add('event.keydown', function (params) {
      var evnt = params.$event;
      var key = getEventKey(evnt.key);
      if (!runEvent(key, disabledMaps, "emit" /* EMIT */, params, evnt)) {
        if (runEvent(key, settingMaps, "trigger" /* TRIGGER */, params, evnt) === false) {
          return false;
        }
        runEvent(key, listenerMaps, "emit" /* EMIT */, params, evnt);
      }
    });
  }
};
if (typeof window !== 'undefined' && window.VXETable && window.VXETable.use) {
  window.VXETable.use(VXETablePluginShortcutKey);
}
var _default = exports["default"] = VXETablePluginShortcutKey;